;**********************************************************************
;                                                                     *
;    Filename:      ff30.inc                                          *
;    Date:          9.3.2009                                          *
;    File Version:  4.6                                               *
;    Copyright:     Mikael Nordman                                    *
;    Author:        Mikael Nordman                                    *
;                                                                     * 
;**********************************************************************
; FlashForth is a standalone Forth system for microcontrollers that
; can flash their own flash memory.
;
; Copyright (C) 2009  Mikael Nordman
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License version 3 as 
; published by the Free Software Foundation.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;
; Modified versions of FlashForth must be clearly marked as such, 
; in the name of this file, and in the identification
; displayed when FlashForth starts.
;**********************************************************************
.ifdef __30F3010
        .include "p30f3010.inc"
.endif
.ifdef __30F3011
        .include "p30f3011.inc"
.endif
.ifdef __30F3012
        .include "p30f3012.inc"
.endif
.ifdef __30F3013
        .include "p30f3013.inc"
.endif
.ifdef __30F3014
        .include "p30f3014.inc"
.endif
.ifdef __30F4011
        .include "p30f4011.inc"
.endif
.ifdef __30F4012
        .include "p30f4012.inc"
.endif
.ifdef __30F4013
        .include "p30f4013.inc"
.endif
.ifdef __30F5011
        .include "p30f5011.inc"
.endif
.ifdef __30F5013
        .include "p30f5013.inc"
.endif
.ifdef __30F5015
        .include "p30f5015.inc"
.endif
.ifdef __30F5016
        .include "p30f5016.inc"
.endif
.ifdef __30F6010
        .include "p30f6011.inc"
.endif
.ifdef __30F6011
        .include "p30f6011.inc"
.endif
.ifdef __30F6012
        .include "p30f6012.inc"
.endif
.ifdef __30F6013
        .include "p30f6013.inc"
.endif
.ifdef __30F6014
        .include "p30f6014.inc"
.endif
.ifdef __30F6015
        .include "p30f6015.inc"
.endif

;..............................................................................
;Configuration bits:
;..............................................................................

config __FOSC,  HS            ;Turn off clock switching and
                              ;fail-safe clock monitoring and
                              ;use the FRC Clock as the
                              ;system clock

config __FWDT, WDT_ON              ;Turn on Watchdog Timer

config __FBORPOR, PBOR_OFF & BORV_27 & PWRT_16 & MCLR_EN
                                    ;Set Brown-out Reset voltage and
                                    ;and set Power-up Timer to 16msecs
                                            
config __FGS, CODE_PROT_OFF         ;Set Code Protection Off


.equ FREQ, 16000000							; Clock (Crystal)frequency (Hz)
;.equ FREQ, 7372800							; Clock (Crystal)frequency (Hz)
.equ BAUDRATE, 2400						; Serial baudrate


.equ BAUD_DIV1, (FREQ/4/(16*BAUDRATE))-1		; UART divisor
.equ MS_PR_VAL, (FREQ/4/1000)					; Timer value for 1 ms ticks

; Set to one to use the alternate UART pins
.equ USE_ALTERNATE_UART_PINS, 1

; Flash write delay
.equ write_delay, 20

; Set to 1 for extra debug info after a exception reset
.equ DEBUG_INFO, 1

; Set to 1 to allow control-o to reset FlashForth
.equ CTRL_O_WARM_RESET, 1

; Modify to change code to enter warm reset
.equ CTRL_O_WARM_RESET_VAL,	15
